Attribute VB_Name = "Subroutine"
' Identify the read Telegrams
Public Sub Identify()

    If Form1.Serial.InBufferCount < 1 Then
        Exit Sub
    End If
    
    Do                                                                  ' Read the data in the serial port.
        dummy = DoEvents()
    Loop Until Form1.Serial.InBufferCount >= 1

    Instring = Form1.Serial.Input                                       ' Read all what is momentary in COM buffer
    Characters_received = Len(Instring)                                 ' Find how many characters are received
    
    ' Write int the ring buffer
    For Input_Pointer = 1 To Characters_received                        ' Get characters into ring buffer
        If RXD_RingBuffer_Pointer < Ring_Buffer_lenght Then             ' Test position in ringbuffer
            RXD_RingBuffer_Pointer = RXD_RingBuffer_Pointer + 1         ' and go to next place
        Else
            RXD_RingBuffer_Pointer = 1                                  ' or wrap ringbuffer around
        End If
        
        RXD_RingBuffer(RXD_RingBuffer_Pointer) = Asc(Mid(Instring, Input_Pointer, 1)) ' Write to ring buffer
    
    Next Input_Pointer
       
    ' define helper size-variable for untreated caracter handling
    If RXD_RingBuffer_Pointer > Last_RingBuffer_Pointer Then            ' Different calulation when wrapping
        Chars_in_Buffer = RXD_RingBuffer_Pointer - Last_RingBuffer_Pointer  ' without wrap
    Else
        Chars_in_Buffer = Ring_Buffer_lenght - Last_RingBuffer_Pointer + RXD_RingBuffer_Pointer ' with wrap
    End If
        
    ' Start telegram dedection only when at least telegram length reached
    While Chars_in_Buffer >= (Telegrams_Lenght)                         ' Lenght  enough for a valid Telegrams
        If Last_RingBuffer_Pointer < Ring_Buffer_lenght Then            ' Test Telegrams position in ringbuffer
            Last_RingBuffer_Pointer = Last_RingBuffer_Pointer + 1       ' and go to next place
        Else
            Last_RingBuffer_Pointer = 1                                 ' or wrap Telgramm pointer around
        End If
        
        Chars_in_Buffer = Chars_in_Buffer - 1                           ' Decrease before search of Sync character
        
        ' Logic to search free telegamm buffer
        Telegrams_Untreated = 0
        Do While (Mid(Telegrams(Telegrams_Untreated), (Telegrams_Lenght), 1) = "U")
            Telegrams_Untreated = Telegrams_Untreated + 1               ' Try next place
            If Telegrams_Untreated >= Max_Telegrams Then
                Telegrams_Untreated = Max_Telegrams                     ' Safety statement for stability
                Exit Do
            End If
        Loop
        
        ' write a telegram and mark it with U = untreated
        If RXD_RingBuffer(Last_RingBuffer_Pointer) = Sync Then          ' Start reading characters after sync character
            Telegrams(Telegrams_Untreated) = ""                         ' Zero old Telegrams data
            For I = 1 To (Telegrams_Lenght - 1)
                If Last_RingBuffer_Pointer < Ring_Buffer_lenght Then                ' Test read position in ringbuffer
                    Last_RingBuffer_Pointer = Last_RingBuffer_Pointer + 1           ' and go to next place
                Else
                    Last_RingBuffer_Pointer = 1                                     ' or wrap readpointer around
                End If
                Telegrams(Telegrams_Untreated) = Telegrams(Telegrams_Untreated) & Chr(RXD_RingBuffer(Last_RingBuffer_Pointer))
                Chars_in_Buffer = Chars_in_Buffer - 1                               ' One was read so decrease
            Next I
            Telegrams(Telegrams_Untreated) = Telegrams(Telegrams_Untreated) & "U"   ' Letter U means untreated telegram
        End If
    Wend

End Sub

' Get the datas of the Telegrams
Public Sub Analyse_Telegrams()
    Telegram_Untreated = 0
    For I = 0 To (Max_Telegrams)                                        ' Start controlling the telgrams as string
        If Mid(Telegrams(I), 9, 1) = "U" Then                           ' and convert them when marked as U = untreated
            Do While Telegram(Telegram_Untreated).Treated = False
                Telegram_Untreated = Telegram_Untreated + 1
                If Telegram_Untreated >= Max_Telegrams Then
                    Telegram_Untreated = Max_Telegrams
                    Exit Do
                End If
            Loop
            ' String to byte conversion                                 ' into the byte form
            Telegram(Telegram_Untreated).DAD = Asc(Mid(Telegrams(I), 1, 1))
            Telegram(Telegram_Untreated).SAD = Asc(Mid(Telegrams(I), 2, 1))
            Telegram(Telegram_Untreated).CMD = Asc(Mid(Telegrams(I), 3, 1))
            Telegram(Telegram_Untreated).Db1 = Asc(Mid(Telegrams(I), 4, 1))
            Telegram(Telegram_Untreated).Db2 = Asc(Mid(Telegrams(I), 5, 1))
            Telegram(Telegram_Untreated).Db3 = Asc(Mid(Telegrams(I), 6, 1))
            Telegram(Telegram_Untreated).Db4 = Asc(Mid(Telegrams(I), 7, 1))
            Telegram(Telegram_Untreated).CRC = Asc(Mid(Telegrams(I), 8, 1))
            ' Calculation of CRC
            CRC = Sync Xor Telegram(Telegram_Untreated).DAD                              ' Calculation starts witch sync caracter !!!
            CRC = CRC Xor Telegram(Telegram_Untreated).SAD
            CRC = CRC Xor Telegram(Telegram_Untreated).CMD
            CRC = CRC Xor Telegram(Telegram_Untreated).Db1
            CRC = CRC Xor Telegram(Telegram_Untreated).Db2
            CRC = CRC Xor Telegram(Telegram_Untreated).Db3
            CRC = CRC Xor Telegram(Telegram_Untreated).Db4
            ' Compare CRC's
            If Telegram(Telegram_Untreated).CRC = CRC Then                               ' Compare telegram CRC
                Telegram(Telegram_Untreated).OK = True                                   ' with calculated CRC
            Else
                Telegram(Telegram_Untreated).OK = False
            End If
            
            ' Decide if the telegram is for this station
            If Telegram(Telegram_Untreated).DAD = Mystation Then                         ' Set flag when for this station
                Telegram(Telegram_Untreated).Mystation = True                            ' It has to be handled
                Telegram(Telegram_Untreated).Treated = False                             ' Reserve space from next conversion
            Else
                Telegram(Telegram_Untreated).Mystation = False                           ' Not for this station so
                Telegram(Telegram_Untreated).Treated = True                              ' give space free for next conversion
            End If
            
            Mid(Telegrams(I), 9, 1) = "T"                               ' Mark string telegram as treated
        End If
    Next I
End Sub

' Treat the read Telegrams
Public Sub TreatTelegrams()
   Dim Pointer As Long
    
   For I = 0 To (Max_Telegrams)                                        ' Start controlling the telgrams as string
        If Telegram(I).Treated = False Then                             ' and convert them when marked as U = untreated
            'Pointer = Rx.Data.Byt(1) Mod 16
            Pointer = Telegram(I).CMD
            Form1.rCMD = Telegram(I).CMD
            Form1.rDb1 = Telegram(I).Db1
            Form1.rDb2 = Telegram(I).Db2
            Form1.rDb3 = Telegram(I).Db3
            Form1.rDb4 = Telegram(I).Db4
            Select Case Pointer
                   Case 16 To 31
                        Form1.Pointer = Pointer
                        Form1.R1(Pointer - 16) = Telegram(I).Db1
                        Form1.R2(Pointer - 16) = Telegram(I).Db2
                        Form1.R3(Pointer - 16) = Telegram(I).Db3
                        Form1.R4(Pointer - 16) = Telegram(I).Db4
                   Case Else
            End Select
            Telegram(I).Treated = True
        End If
   Next I
End Sub

Public Sub Showthem()
        Form1.TxtReceive.Text = ""
        For I = 0 To Max_Telegrams
           Form1.TxtReceive.Text = Form1.TxtReceive.Text & Telegrams(I) & vbTab
        Next I
        
        Form1.Untreat(1) = Telegram_Untreated
        Form1.Untreat(0) = Telegrams_Untreated
     
        Form1.TelegramView.Text = ""
        For I = 0 To Max_Telegrams
            Form1.TelegramView.Text = Form1.TelegramView.Text & I & "->"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).DAD & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).SAD & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).CMD & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Db1 & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Db2 & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Db3 & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Db4 & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).CRC & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).OK & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Mystation & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & Telegram(I).Treated & "-"
            Form1.TelegramView.Text = Form1.TelegramView.Text & vbCrLf
        Next I


End Sub

 Public Sub Send_Cmds()
    
    Dim Outstring As String
    
    ' Calculation of CRC
    sCRC = Sync Xor sDAD                                                ' Calculation starts witch sync caracter !!!
    sCRC = sCRC Xor Mystation
    sCRC = sCRC Xor sCMD
    sCRC = sCRC Xor sDb1
    sCRC = sCRC Xor sDb2
    sCRC = sCRC Xor sDb3
    sCRC = sCRC Xor sDb4

    Outstring = Chr(Sync) & Chr(sDAD) & Chr(Mystation) & Chr(sCMD) & _
                Chr(sDb1) & Chr(sDb2) & Chr(sDb3) & Chr(sDb4) & Chr(sCRC)
   
    Form1.Serial.Output = Outstring                                     ' Write to COM buffer

    
End Sub

' Read the Parameter file
Public Sub Read_Intfile()

  Dim I As Integer
  Dim LineString As String
  Dim Gateslist(10) As String
      
  Open "home.INT" For Input As #1    ' Header Datei ffnen
  
  'Copy Header file to Outputfile
  I = 1
  Do While Not EOF(1)
    Line Input #1, LineString
    If Mid(LineString, 1, 1) <> "'" Then
       If Mid(LineString, 1, 3) = "COM" Then                          ' Only Port parameters
            PortNr = Val(Mid(LineString, 4, 1))                        ' Number of the COM port
            PortParameter = Mid(LineString, 6, 20)                     ' Parameters of the COM port
       End If
       
       If Mid(LineString, 1, 4) = "GATE" Then                          ' Only Port parameters
            PortParameter = Mid(LineString, 6, 20)                     ' Parameters of the COM port
       End If
       
       Form1.Text1.Text = Form1.Text1.Text & LineString & vbCrLf
       I = I + 1                                                       ' Next line in file
    End If

  Loop                                                                 ' Till end of file reached
  Close #1
End Sub

'Pause subroutine
Public Sub Pause(Millisec)
    T1# = Timer + Millisec / 1000
    Do
        x% = DoEvents()
    Loop While Timer < T1#
End Sub

